<?php
if( !class_exists('QuoteRotator') ) :

class QuoteRotator
{
	var $tableName;
	var $pluginPath;
	var $currentVersion;
	
	function QuoteRotator()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$this->currentVersion = '3.4.2';
		$this->tableName = $wpdb->prefix . 'QuoteRotator';
		$this->pluginPath = get_settings('siteurl') . '/wp-content/plugins/quote-rotator/';
		
		$options = get_option('widgetQuoteRotator');
		$options['version'] = $this->currentVersion;
		update_option('widgetQuoteRotator', $options);
	}
	
	function createDatabaseTable()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$options = array();
		$options['title'] = 'Quote Rotator';
		$options['delay'] = 5;
		$options['fade'] = 2;
		$options['fontsize'] = 12;
		$options['fontunit'] = 'px';
		
		if( !get_option('widgetQuoteRotator') )
		{
			add_option('widgetQuoteRotator', $options);
		}
		
		if( $wpdb->get_var("SHOW TABLES LIKE `" . $this->tableName . "`") != $this->tableName)
		{
			$sql = "CREATE TABLE `" . $wpdb->prefix . "QuoteRotator` (`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT PRIMARY KEY, `quote` TEXT NULL);";
			//$sql = "CREATE TABLE `" . $this->tableName . "` (`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT PRIMARY KEY, `quote` TEXT NULL);";
			require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
			dbDelta($sql);
			$options['version'] = $this->currentVersion;
		}
		$sql = "ALTER TABLE `" . $this->tableName . "` ADD `author` VARCHAR(255) NOT NULL AFTER `quote`;";
		$wpdb->query($sql);
		$sql = "RENAME TABLE `wp_QuoteRotator` TO `$this->tableName`;";
		$wpdb->query($sql);
		$sql = "ALTER TABLE `" . $this->tableName . "` CHANGE `quote` `quote` TEXT NULL;";
		$wpdb->query($sql);
		update_option('widgetQuoteRotator', $options);
		delete_option('widgetizeQuoteRotator');		
	}
	
	function deleteDatabaseTable()
	{
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		delete_option('widgetQuoteRotator');
		//global $wpdb;
		
		//$sql = "DROP TABLE IF EXISTS " . $this->tableName . ";";	
		//$wpdb->query($sql);
	}
	
	function addHeaderContent()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$options = get_option('widgetQuoteRotator');
		
		if($options['random']==1)
			$sql = "SELECT * FROM " . $this->tableName . " ORDER BY RAND(".time().")";
		else
			$sql = "SELECT * FROM " . $this->tableName . " ORDER BY id";
		$results = $wpdb->get_results($sql);
		
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/prototype.js\" type=\"text/javascript\"></script>\n";
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/scriptaculous.js\" type=\"text/javascript\"></script>\n";
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/effects.js\" type=\"text/javascript\"></script>\n";
		
		echo "<script type=\"text/javascript\">\n";
		echo "quoteRotator = {\n";
		echo "\"i\":1,\n";
		echo "\"quotes\" : [\n";
		$i=0;
		foreach($results as $result){
			echo "\"$result->quote";
			if($result->author != '')
				echo "<b>--$result->author</b>";
			echo "\",\n";
			$i++;
		}
		echo "],\n";
		echo "\"num_quotes\" : $i,\n";
		echo "\t\"opac\":100,\n";
		echo "\t\"showFading\":1,\n";
		echo "\"quotesInit\":function(){\n";
		echo "\tif(this.num_quotes>0){\n";
		echo "\tdocument.getElementById('quoterotator').style.opacity=0.0\n";
		echo "\tdocument.getElementById('quoterotator').style.filter=\"alpha(opacity=0.0)\"\n";
		echo "\tnew Effect.Appear('quoterotator',{duration:".  $options['fade'] . "})\n";
		echo "\t\tdocument.getElementById('quoterotator').innerHTML=this.quotes[0]\n";
		echo "\t}\n";
		echo "\telse{\n";
		echo "\t\tdocument.getElementById('quoterotator').innerHTML=\"No Quotes Found!!!\"\n";
		echo "\t}\n";
		echo "\tif(this.num_quotes>1){\n";
		echo "\t\tsetInterval(\"quoteRotator.quoteRotate()\", " . ($options['delay']*1000+$options['fade']*1000) . ")\n";
		echo "\t}\n";
		echo "},\n";
		echo "\"quoteRotate\":function(){\n";
		echo "\tdocument.getElementById('quoterotator').style.opacity=0.0\n";
		echo "\tdocument.getElementById('quoterotator').style.filter=\"alpha(opacity=0.0)\"\n";
		echo "\tnew Effect.Appear('quoterotator',{duration:" . $options['fade'] . "})\n";
		echo "\tdocument.getElementById('quoterotator').innerHTML=this.quotes[this.i]\n";
		echo "\tthis.i++\n";
		echo "\tif(this.i==this.num_quotes){\n";
		echo "\t\tthis.i=0\n";
		echo "\t}\n";
		echo "}\n";
		echo "}\n";
		echo "</script>";
	}
		
	function displayWidget($args)
	{
		extract($args);
		
		$options = get_option('widgetQuoteRotator');
		$title = $options['title'];
		$fontsize = $options['fontsize'];
		$fontunit = $options['fontunit'];
		
		echo $before_widget . $before_title . $title . $after_title;
		
		echo "<div id=\"quoterotator\" style=\"font-size:$fontsize$fontunit;\">\n";
		echo "Loading Quotes...\n";
		echo "</div>\n";
		echo "<script type=\"text/javascript\">setTimeout(\"quoteRotator.quotesInit()\", 2000)</script>\n";
		
		echo $after_widget;
	}
}

endif;
?>