<?php
/*
Plugin Name: Quote Rotator
Plugin URI: http://www.lukehowell.com/?page_id=44
Description: Creates widget to rotate user entered Quotes.
Version: 3.5.2
Author: Luke Howell
Author URI: http://www.lukehowell.com/

---------------------------------------------------------------------
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------------
*/

require_once('classes/quote-rotator.class.php');
require_once('classes/quote-rotator-management.class.php');

if( class_exists('QuoteRotator') && class_exists('QuoteRotatorManagement') ) :

$quoteRotator = new QuoteRotator();
$management = new QuoteRotatorManagement();

if( isset($quoteRotator) && isset($management) )
{
	if($_GET['action']=="delete-quote")
	{
		$management->deleteQuote($_GET['id']);
	}

	if($_POST['addQuote'] == 1)
	{
		$management->addQuote($_POST['quote'], $_POST['author']);
	}
	
	if($_POST['editQuote'] == 1)
	{
		$management->editQuote($_POST['quote'], $_POST['author'], $_POST['id']);
	}
	
	function widgetInit()
	{
		global $quoteRotator, $management;
		
		if( !function_exists('register_sidebar_widget') )
		{
			return;
		}
		
		register_sidebar_widget('Quote', array(&$quoteRotator, 'displayWidget'));
		register_widget_control('Quote', array(&$management, 'displayWidgetControl'), 375, 200);
	}
	
	function managementInit()
	{
		global $management;
		
		wp_enqueue_script( 'listman' );
		add_management_page('Quote Rotator', 'Quote Rotator', 10, basename(__FILE__), array(&$management, 'displayManagementPage'));
	}
	
	add_action('activate_quote-rotator/quote-rotator.php', array(&$quoteRotator, 'createDatabaseTable'));
	add_action('deactivate_quote-rotator/quote-rotator.php', array(&$quoteRotator, 'deleteDatabaseTable'));
	add_action('wp_head', array(&$quoteRotator, 'addHeaderContent'));
	add_action('wp_ajax_delete-quote', array(&$management, 'ajaxDelete'));
	add_action('admin_menu', 'managementInit');
	add_action('plugins_loaded', 'widgetInit');
}

endif;
?>